/******************************************************************
 *
 * Name:	Plugin_procs.c
 * 
 * Description:
 * 
 * Author:	Tomasz Stachowiak
 *
 * Date:	23/07/96
 *
 * Change Log:
 *
 ********************************************************************/

#include <stdio.h>
#include <sys/types.h>


#include <Xm/Xm.h>

#include "../lib/common.h"

#include "TSBoardPluginMotif.h"
#include "BoardPluginProtocol.h"

int current_state;
extern XtAppContext app;

extern ncsapp;

/**********************************************************************
 *
 * Functions kept for OpenDVE_procs.c compatibility
 *
 *********************************************************************/
void QueryPluginStatus()
{
  char msh[10];
  ncsAppSendPriorityData(ncsapp, 0, QUERY, msh, 10);
}

/********************************************************************
 *
 * Messages sending
 *
 *******************************************************************/
void sendDVEobject(boardPluginMessageStructure *obj)
  {
   boardPluginMessageStructure *msg;

   msg = malloc(sizeof(boardPluginMessageStructure));
   if (!msg)
   {
     printf("Message allocation error\n");
     return;
   }

   memcpy(msg, obj, sizeof(boardPluginMessageStructure));

   if(ncsAppSendPriorityData(ncsapp, -1, OBJECT, msg, 
		     sizeof(boardPluginMessageStructure)) < 0)
		printf("Sending failure\n");

   return;
  }


void
SendClear()
{
   boardPluginMessageStructure *msg;

   msg = malloc(sizeof(boardPluginMessageStructure));

   if (!msg)
   {
     printf("Message allocation error\n");
     return;
   }
 

   if(ncsAppSendPriorityData(ncsapp, -1, CLEAR, msg, 
		     sizeof(boardPluginMessageStructure)) < 0)
		printf("Sending failure\n");

   return;
}


/**************************************************************************
 *
 * Function processing incoming messages
 *
 *************************************************************************/
void 
ProcessPluginMessage(int messageType, void *data) 
{
   boardPluginMessageStructure message;
   memcpy(&message, data, sizeof(boardPluginMessageStructure));
   

   switch (messageType){
      case OBJECT:
	 obj_addobj(&message);
	 obj_draw(&message);
	 break;
      case CLEAR:
	 Clear();
	 obj_removeall();
	 break;
      case QUERY:
	 obj_sendall();
	 break;
   }
}


void ncsPriorityDataCallback(int type, int sender, void *data, int len)
{
  ProcessPluginMessage(type, data);
}

/*********************************************************************
 *
 * Plugin management functions
 *
 ********************************************************************/
void 
ShowPlugin(void)
{
  /*   fprintf(stderr, "ShowPlugin\n");*/
}

void 
HidePlugin(void)
{
  /*   fprintf(stderr, "HidePlugin\n");*/
}

void 
CleanupPlugin(void)
{
}


/************************** END Plugin_procs.c **************************/








